unsigned char LeggiChar(unsigned char indirizzo)
{
    unsigned char valoreLetto;

    EEADR=indirizzo; //assegno al registro EEADR l'indirizzo in cui  memorizzato il dato
    EEPGD=0; //setto il registro a 0 per indicare che voglio leggere dalla memoria programma
    RD=1; //avvio il ciclo di lettura
    valoreLetto=EEDATA; //leggo il dato memorizzato nel registro EEDATA

    return valoreLetto; //assegno alla funzione il valore letto
}
 
void ScriviChar(unsigned char dato, unsigned char indirizzo)
{
    char interruptAttivi=0;
    EEADR=indirizzo; //assegno al registro EEADR l'indirizzo in cui memorizzare il dato
    EEDATA=dato; //assegno al registro EEDATA il dato da memorizzare
    EEPGD=0; //setto il registro a 0 per indicare che voglio scrivere nella memoria programma
    WREN=1; //abilito la scrittura sull'eeprom

    if(GIE) //se gli interrupt sono attivi
    {
        interruptAttivi=1; //ne memorizzo lo stato di "attivato"
        GIE=0; //disabilito gli interrupt (vedi datasheet)
    }

    EECON2=0x55; //scrivo il numero 0x55 sul registro EECON2 (vedi datasheet)
    EECON2=0xAA; //scrivo il numero 0xAA sul registro EECON2 (vedi datasheet)

    WR=1; //avvio il ciclo di scrittura

    while(!EEIF); //verifico che la scrittura sia completata prima di eseguire altre operazioni
    WREN=0; //disabilito la scrittura sull'eeprom
    EEIF=0; //resetto il flag di interrupt di scrittura completata

    if(interruptAttivi) //se gli interrupt erano attivi
    {
        GIE=1; //riattivo gli interrupt
    }
}
